# coding: utf-8

"""
    Laserfiche Repository API

    Welcome to the Laserfiche API Swagger Playground. You can try out any of our API calls against your live Laserfiche Cloud account. Visit the developer center for more details: <a href=\"https://developer.laserfiche.com\">https://developer.laserfiche.com</a><p>Visit the changelog for the list of changes: <a href=\"/repository/v2/changelog\">/repository/v2/changelog</a></p><p><strong>Build# : </strong>41a7347c0662989661d7ab8105a70d36cb42518e_.20240124.4</p>  # noqa: E501

    OpenAPI spec version: 2
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class StartExportEntryRequest(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'audit_reason_id': 'int',
        'audit_reason_comment': 'str',
        'part': 'OneOfStartExportEntryRequestPart',
        'image_options': 'OneOfStartExportEntryRequestImageOptions',
        'text_options': 'OneOfStartExportEntryRequestTextOptions'
    }

    attribute_map = {
        'audit_reason_id': 'auditReasonId',
        'audit_reason_comment': 'auditReasonComment',
        'part': 'part',
        'image_options': 'imageOptions',
        'text_options': 'textOptions'
    }

    def __init__(self, audit_reason_id=None, audit_reason_comment='', part=None, image_options=None, text_options=None):  # noqa: E501
        """StartExportEntryRequest - a model defined in Swagger"""  # noqa: E501
        self._audit_reason_id = None
        self._audit_reason_comment = None
        self._part = None
        self._image_options = None
        self._text_options = None
        self.discriminator = None
        if audit_reason_id is not None:
            self.audit_reason_id = audit_reason_id
        if audit_reason_comment is not None:
            self.audit_reason_comment = audit_reason_comment
        self.part = part
        if image_options is not None:
            self.image_options = image_options
        if text_options is not None:
            self.text_options = text_options

    @property
    def audit_reason_id(self):
        """Gets the audit_reason_id of this StartExportEntryRequest.  # noqa: E501

        The reason id for this audit event.  # noqa: E501

        :return: The audit_reason_id of this StartExportEntryRequest.  # noqa: E501
        :rtype: int
        """
        return self._audit_reason_id

    @audit_reason_id.setter
    def audit_reason_id(self, audit_reason_id):
        """Sets the audit_reason_id of this StartExportEntryRequest.

        The reason id for this audit event.  # noqa: E501

        :param audit_reason_id: The audit_reason_id of this StartExportEntryRequest.  # noqa: E501
        :type: int
        """

        self._audit_reason_id = audit_reason_id

    @property
    def audit_reason_comment(self):
        """Gets the audit_reason_comment of this StartExportEntryRequest.  # noqa: E501

        The comment for this audit event.  # noqa: E501

        :return: The audit_reason_comment of this StartExportEntryRequest.  # noqa: E501
        :rtype: str
        """
        return self._audit_reason_comment

    @audit_reason_comment.setter
    def audit_reason_comment(self, audit_reason_comment):
        """Sets the audit_reason_comment of this StartExportEntryRequest.

        The comment for this audit event.  # noqa: E501

        :param audit_reason_comment: The audit_reason_comment of this StartExportEntryRequest.  # noqa: E501
        :type: str
        """

        self._audit_reason_comment = audit_reason_comment

    @property
    def part(self):
        """Gets the part of this StartExportEntryRequest.  # noqa: E501

        Specifies the part of the document to export.  # noqa: E501

        :return: The part of this StartExportEntryRequest.  # noqa: E501
        :rtype: OneOfStartExportEntryRequestPart
        """
        return self._part

    @part.setter
    def part(self, part):
        """Sets the part of this StartExportEntryRequest.

        Specifies the part of the document to export.  # noqa: E501

        :param part: The part of this StartExportEntryRequest.  # noqa: E501
        :type: OneOfStartExportEntryRequestPart
        """
        if part is None:
            raise ValueError("Invalid value for `part`, must not be `None`")  # noqa: E501

        self._part = part

    @property
    def image_options(self):
        """Gets the image_options of this StartExportEntryRequest.  # noqa: E501

        The options applied when exporting as Image.  # noqa: E501

        :return: The image_options of this StartExportEntryRequest.  # noqa: E501
        :rtype: OneOfStartExportEntryRequestImageOptions
        """
        return self._image_options

    @image_options.setter
    def image_options(self, image_options):
        """Sets the image_options of this StartExportEntryRequest.

        The options applied when exporting as Image.  # noqa: E501

        :param image_options: The image_options of this StartExportEntryRequest.  # noqa: E501
        :type: OneOfStartExportEntryRequestImageOptions
        """

        self._image_options = image_options

    @property
    def text_options(self):
        """Gets the text_options of this StartExportEntryRequest.  # noqa: E501

        The options applied when exporting as Text.  # noqa: E501

        :return: The text_options of this StartExportEntryRequest.  # noqa: E501
        :rtype: OneOfStartExportEntryRequestTextOptions
        """
        return self._text_options

    @text_options.setter
    def text_options(self, text_options):
        """Sets the text_options of this StartExportEntryRequest.

        The options applied when exporting as Text.  # noqa: E501

        :param text_options: The text_options of this StartExportEntryRequest.  # noqa: E501
        :type: OneOfStartExportEntryRequestTextOptions
        """

        self._text_options = text_options

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(StartExportEntryRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, StartExportEntryRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
